# IO.Swagger.Api.PointsApi

All URIs are relative to *https://lightning.weathersourceapis.com/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**PointsLatitudelongitudePeriodTimestampStarttimestampEndGet**](PointsApi.md#pointslatitudelongitudeperiodtimestampstarttimestampendget) | **GET** /points/{latitude},{longitude}/period/{timestampStart},{timestampEnd} | Lightning data proximate to a Latitude/Longitude point.

<a name="pointslatitudelongitudeperiodtimestampstarttimestampendget"></a>
# **PointsLatitudelongitudePeriodTimestampStarttimestampEndGet**
> LightningPointObj PointsLatitudelongitudePeriodTimestampStarttimestampEndGet (float? latitude, float? longitude, DateTime? timestampStart, DateTime? timestampEnd, List<string> fields, string unitScale = null, int? limit = null)

Lightning data proximate to a Latitude/Longitude point.

Returns all lightning events that are both within 12 km (7 miles) of a provided Latitude/Longitude point and within the provided time range. The temporal range provided must not exceed 1 year in duration.  **IMPORTANT:** To authenticate to the Weather Source App Weather API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page. 

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PointsLatitudelongitudePeriodTimestampStarttimestampEndGetExample
    {
        public void main()
        {
            // Configure API key authorization: ApiKeyAuth
            Configuration.Default.AddApiKey("X-API-KEY", "YOUR_API_KEY");
            // Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
            // Configuration.Default.AddApiKeyPrefix("X-API-KEY", "Bearer");

            var apiInstance = new PointsApi();
            var latitude = 3.4;  // float? | A latitude value between -90° and 90°.
            var longitude = 3.4;  // float? | A longitude value between -180° (West) and 180° (East).
            var timestampStart = 2013-10-20T19:20:30+01:00;  // DateTime? | A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required.
            var timestampEnd = 2013-10-20T19:20:30+01:00;  // DateTime? | A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required.
            var fields = new List<string>(); // List<string> | A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.** 
            var unitScale = unitScale_example;  // string | The unit scale for returned values.<br> (optional)  (default to IMPERIAL)
            var limit = 56;  // int? | Limit the number of matching events returned. Returned events are ordered by distance from the provided location. Applying a limit will return the nearest events. A value of 0 means no limit.  (optional)  (default to 0)

            try
            {
                // Lightning data proximate to a Latitude/Longitude point.
                LightningPointObj result = apiInstance.PointsLatitudelongitudePeriodTimestampStarttimestampEndGet(latitude, longitude, timestampStart, timestampEnd, fields, unitScale, limit);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PointsApi.PointsLatitudelongitudePeriodTimestampStarttimestampEndGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **latitude** | **float?**| A latitude value between -90° and 90°. | 
 **longitude** | **float?**| A longitude value between -180° (West) and 180° (East). | 
 **timestampStart** | **DateTime?**| A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. | 
 **timestampEnd** | **DateTime?**| A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. | 
 **fields** | [**List&lt;string&gt;**](string.md)| A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  | 
 **unitScale** | **string**| The unit scale for returned values.&lt;br&gt; | [optional] [default to IMPERIAL]
 **limit** | **int?**| Limit the number of matching events returned. Returned events are ordered by distance from the provided location. Applying a limit will return the nearest events. A value of 0 means no limit.  | [optional] [default to 0]

### Return type

[**LightningPointObj**](LightningPointObj.md)

### Authorization

[ApiKeyAuth](../README.md#ApiKeyAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)
