/* 
 * Lightning - A Weather Source API
 *
 * **This API is in BETA release.**  Global lightning archive, updated in real time. The Weather Source Lightning API provides the most accurate and reliable global lightning data available. All matching lightning events within 12 km (7 miles) of a provided location (and within the provided time range) are returned. The global lightning archive is available from the years 2021 and onward.  **IMPORTANT:** To authenticate to the Weather Source Lightning API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page. 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// The OnPoint™ grid on which the resource exists.
    /// </summary>
    /// <value>The OnPoint™ grid on which the resource exists.</value>
    [JsonConverter(typeof(StringEnumConverter))]
        public enum Grid
    {
        /// <summary>
        /// Enum GLOBALGRID for value: GLOBAL_GRID
        /// </summary>
        [EnumMember(Value = "GLOBAL_GRID")]
        GLOBALGRID = 1,
        /// <summary>
        /// Enum NORTHAMERICAGRID for value: NORTH_AMERICA_GRID
        /// </summary>
        [EnumMember(Value = "NORTH_AMERICA_GRID")]
        NORTHAMERICAGRID = 2    }
}
