/* 
 * Lightning - A Weather Source API
 *
 * **This API is in BETA release.**  Global lightning archive, updated in real time. The Weather Source Lightning API provides the most accurate and reliable global lightning data available. All matching lightning events within 12 km (7 miles) of a provided location (and within the provided time range) are returned. The global lightning archive is available from the years 2021 and onward.  **IMPORTANT:** To authenticate to the Weather Source Lightning API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.  When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page. 
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// A lightning object.
    /// </summary>
    [DataContract]
        public partial class LightningObj :  IEquatable<LightningObj>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="LightningObj" /> class.
        /// </summary>
        /// <param name="timestamp">timestamp (required).</param>
        /// <param name="latitude">latitude (required).</param>
        /// <param name="longitude">longitude (required).</param>
        /// <param name="distance">distance.</param>
        /// <param name="peakCurrent">peakCurrent.</param>
        /// <param name="flashMult">flashMult.</param>
        /// <param name="sensorCnt">sensorCnt.</param>
        /// <param name="df">df.</param>
        /// <param name="t">t.</param>
        /// <param name="su">su.</param>
        /// <param name="sv">sv.</param>
        /// <param name="chi2">chi2.</param>
        /// <param name="riseTime">riseTime.</param>
        /// <param name="fallTime">fallTime.</param>
        /// <param name="rateOfChange">rateOfChange.</param>
        /// <param name="cloudFlag">cloudFlag.</param>
        /// <param name="angleFlag">angleFlag.</param>
        /// <param name="signalFlag">signalFlag.</param>
        /// <param name="timingFlag">timingFlag.</param>
        public LightningObj(DateTime? timestamp = default(DateTime?), float? latitude = default(float?), float? longitude = default(float?), float? distance = default(float?), int? peakCurrent = default(int?), int? flashMult = default(int?), int? sensorCnt = default(int?), int? df = default(int?), float? t = default(float?), float? su = default(float?), float? sv = default(float?), float? chi2 = default(float?), float? riseTime = default(float?), float? fallTime = default(float?), float? rateOfChange = default(float?), bool? cloudFlag = default(bool?), bool? angleFlag = default(bool?), bool? signalFlag = default(bool?), bool? timingFlag = default(bool?))
        {
            // to ensure "timestamp" is required (not null)
            if (timestamp == null)
            {
                throw new InvalidDataException("timestamp is a required property for LightningObj and cannot be null");
            }
            else
            {
                this.Timestamp = timestamp;
            }
            // to ensure "latitude" is required (not null)
            if (latitude == null)
            {
                throw new InvalidDataException("latitude is a required property for LightningObj and cannot be null");
            }
            else
            {
                this.Latitude = latitude;
            }
            // to ensure "longitude" is required (not null)
            if (longitude == null)
            {
                throw new InvalidDataException("longitude is a required property for LightningObj and cannot be null");
            }
            else
            {
                this.Longitude = longitude;
            }
            this.Distance = distance;
            this.PeakCurrent = peakCurrent;
            this.FlashMult = flashMult;
            this.SensorCnt = sensorCnt;
            this.Df = df;
            this.T = t;
            this.Su = su;
            this.Sv = sv;
            this.Chi2 = chi2;
            this.RiseTime = riseTime;
            this.FallTime = fallTime;
            this.RateOfChange = rateOfChange;
            this.CloudFlag = cloudFlag;
            this.AngleFlag = angleFlag;
            this.SignalFlag = signalFlag;
            this.TimingFlag = timingFlag;
        }
        
        /// <summary>
        /// Gets or Sets Timestamp
        /// </summary>
        [DataMember(Name="timestamp", EmitDefaultValue=false)]
        public DateTime? Timestamp { get; set; }

        /// <summary>
        /// Gets or Sets Latitude
        /// </summary>
        [DataMember(Name="latitude", EmitDefaultValue=false)]
        public float? Latitude { get; set; }

        /// <summary>
        /// Gets or Sets Longitude
        /// </summary>
        [DataMember(Name="longitude", EmitDefaultValue=false)]
        public float? Longitude { get; set; }

        /// <summary>
        /// Gets or Sets Distance
        /// </summary>
        [DataMember(Name="distance", EmitDefaultValue=false)]
        public float? Distance { get; set; }

        /// <summary>
        /// Gets or Sets PeakCurrent
        /// </summary>
        [DataMember(Name="peakCurrent", EmitDefaultValue=false)]
        public int? PeakCurrent { get; set; }

        /// <summary>
        /// Gets or Sets FlashMult
        /// </summary>
        [DataMember(Name="flashMult", EmitDefaultValue=false)]
        public int? FlashMult { get; set; }

        /// <summary>
        /// Gets or Sets SensorCnt
        /// </summary>
        [DataMember(Name="sensorCnt", EmitDefaultValue=false)]
        public int? SensorCnt { get; set; }

        /// <summary>
        /// Gets or Sets Df
        /// </summary>
        [DataMember(Name="df", EmitDefaultValue=false)]
        public int? Df { get; set; }

        /// <summary>
        /// Gets or Sets T
        /// </summary>
        [DataMember(Name="t", EmitDefaultValue=false)]
        public float? T { get; set; }

        /// <summary>
        /// Gets or Sets Su
        /// </summary>
        [DataMember(Name="su", EmitDefaultValue=false)]
        public float? Su { get; set; }

        /// <summary>
        /// Gets or Sets Sv
        /// </summary>
        [DataMember(Name="sv", EmitDefaultValue=false)]
        public float? Sv { get; set; }

        /// <summary>
        /// Gets or Sets Chi2
        /// </summary>
        [DataMember(Name="chi2", EmitDefaultValue=false)]
        public float? Chi2 { get; set; }

        /// <summary>
        /// Gets or Sets RiseTime
        /// </summary>
        [DataMember(Name="riseTime", EmitDefaultValue=false)]
        public float? RiseTime { get; set; }

        /// <summary>
        /// Gets or Sets FallTime
        /// </summary>
        [DataMember(Name="fallTime", EmitDefaultValue=false)]
        public float? FallTime { get; set; }

        /// <summary>
        /// Gets or Sets RateOfChange
        /// </summary>
        [DataMember(Name="rateOfChange", EmitDefaultValue=false)]
        public float? RateOfChange { get; set; }

        /// <summary>
        /// Gets or Sets CloudFlag
        /// </summary>
        [DataMember(Name="cloudFlag", EmitDefaultValue=false)]
        public bool? CloudFlag { get; set; }

        /// <summary>
        /// Gets or Sets AngleFlag
        /// </summary>
        [DataMember(Name="angleFlag", EmitDefaultValue=false)]
        public bool? AngleFlag { get; set; }

        /// <summary>
        /// Gets or Sets SignalFlag
        /// </summary>
        [DataMember(Name="signalFlag", EmitDefaultValue=false)]
        public bool? SignalFlag { get; set; }

        /// <summary>
        /// Gets or Sets TimingFlag
        /// </summary>
        [DataMember(Name="timingFlag", EmitDefaultValue=false)]
        public bool? TimingFlag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class LightningObj {\n");
            sb.Append("  Timestamp: ").Append(Timestamp).Append("\n");
            sb.Append("  Latitude: ").Append(Latitude).Append("\n");
            sb.Append("  Longitude: ").Append(Longitude).Append("\n");
            sb.Append("  Distance: ").Append(Distance).Append("\n");
            sb.Append("  PeakCurrent: ").Append(PeakCurrent).Append("\n");
            sb.Append("  FlashMult: ").Append(FlashMult).Append("\n");
            sb.Append("  SensorCnt: ").Append(SensorCnt).Append("\n");
            sb.Append("  Df: ").Append(Df).Append("\n");
            sb.Append("  T: ").Append(T).Append("\n");
            sb.Append("  Su: ").Append(Su).Append("\n");
            sb.Append("  Sv: ").Append(Sv).Append("\n");
            sb.Append("  Chi2: ").Append(Chi2).Append("\n");
            sb.Append("  RiseTime: ").Append(RiseTime).Append("\n");
            sb.Append("  FallTime: ").Append(FallTime).Append("\n");
            sb.Append("  RateOfChange: ").Append(RateOfChange).Append("\n");
            sb.Append("  CloudFlag: ").Append(CloudFlag).Append("\n");
            sb.Append("  AngleFlag: ").Append(AngleFlag).Append("\n");
            sb.Append("  SignalFlag: ").Append(SignalFlag).Append("\n");
            sb.Append("  TimingFlag: ").Append(TimingFlag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as LightningObj);
        }

        /// <summary>
        /// Returns true if LightningObj instances are equal
        /// </summary>
        /// <param name="input">Instance of LightningObj to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(LightningObj input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Timestamp == input.Timestamp ||
                    (this.Timestamp != null &&
                    this.Timestamp.Equals(input.Timestamp))
                ) && 
                (
                    this.Latitude == input.Latitude ||
                    (this.Latitude != null &&
                    this.Latitude.Equals(input.Latitude))
                ) && 
                (
                    this.Longitude == input.Longitude ||
                    (this.Longitude != null &&
                    this.Longitude.Equals(input.Longitude))
                ) && 
                (
                    this.Distance == input.Distance ||
                    (this.Distance != null &&
                    this.Distance.Equals(input.Distance))
                ) && 
                (
                    this.PeakCurrent == input.PeakCurrent ||
                    (this.PeakCurrent != null &&
                    this.PeakCurrent.Equals(input.PeakCurrent))
                ) && 
                (
                    this.FlashMult == input.FlashMult ||
                    (this.FlashMult != null &&
                    this.FlashMult.Equals(input.FlashMult))
                ) && 
                (
                    this.SensorCnt == input.SensorCnt ||
                    (this.SensorCnt != null &&
                    this.SensorCnt.Equals(input.SensorCnt))
                ) && 
                (
                    this.Df == input.Df ||
                    (this.Df != null &&
                    this.Df.Equals(input.Df))
                ) && 
                (
                    this.T == input.T ||
                    (this.T != null &&
                    this.T.Equals(input.T))
                ) && 
                (
                    this.Su == input.Su ||
                    (this.Su != null &&
                    this.Su.Equals(input.Su))
                ) && 
                (
                    this.Sv == input.Sv ||
                    (this.Sv != null &&
                    this.Sv.Equals(input.Sv))
                ) && 
                (
                    this.Chi2 == input.Chi2 ||
                    (this.Chi2 != null &&
                    this.Chi2.Equals(input.Chi2))
                ) && 
                (
                    this.RiseTime == input.RiseTime ||
                    (this.RiseTime != null &&
                    this.RiseTime.Equals(input.RiseTime))
                ) && 
                (
                    this.FallTime == input.FallTime ||
                    (this.FallTime != null &&
                    this.FallTime.Equals(input.FallTime))
                ) && 
                (
                    this.RateOfChange == input.RateOfChange ||
                    (this.RateOfChange != null &&
                    this.RateOfChange.Equals(input.RateOfChange))
                ) && 
                (
                    this.CloudFlag == input.CloudFlag ||
                    (this.CloudFlag != null &&
                    this.CloudFlag.Equals(input.CloudFlag))
                ) && 
                (
                    this.AngleFlag == input.AngleFlag ||
                    (this.AngleFlag != null &&
                    this.AngleFlag.Equals(input.AngleFlag))
                ) && 
                (
                    this.SignalFlag == input.SignalFlag ||
                    (this.SignalFlag != null &&
                    this.SignalFlag.Equals(input.SignalFlag))
                ) && 
                (
                    this.TimingFlag == input.TimingFlag ||
                    (this.TimingFlag != null &&
                    this.TimingFlag.Equals(input.TimingFlag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Timestamp != null)
                    hashCode = hashCode * 59 + this.Timestamp.GetHashCode();
                if (this.Latitude != null)
                    hashCode = hashCode * 59 + this.Latitude.GetHashCode();
                if (this.Longitude != null)
                    hashCode = hashCode * 59 + this.Longitude.GetHashCode();
                if (this.Distance != null)
                    hashCode = hashCode * 59 + this.Distance.GetHashCode();
                if (this.PeakCurrent != null)
                    hashCode = hashCode * 59 + this.PeakCurrent.GetHashCode();
                if (this.FlashMult != null)
                    hashCode = hashCode * 59 + this.FlashMult.GetHashCode();
                if (this.SensorCnt != null)
                    hashCode = hashCode * 59 + this.SensorCnt.GetHashCode();
                if (this.Df != null)
                    hashCode = hashCode * 59 + this.Df.GetHashCode();
                if (this.T != null)
                    hashCode = hashCode * 59 + this.T.GetHashCode();
                if (this.Su != null)
                    hashCode = hashCode * 59 + this.Su.GetHashCode();
                if (this.Sv != null)
                    hashCode = hashCode * 59 + this.Sv.GetHashCode();
                if (this.Chi2 != null)
                    hashCode = hashCode * 59 + this.Chi2.GetHashCode();
                if (this.RiseTime != null)
                    hashCode = hashCode * 59 + this.RiseTime.GetHashCode();
                if (this.FallTime != null)
                    hashCode = hashCode * 59 + this.FallTime.GetHashCode();
                if (this.RateOfChange != null)
                    hashCode = hashCode * 59 + this.RateOfChange.GetHashCode();
                if (this.CloudFlag != null)
                    hashCode = hashCode * 59 + this.CloudFlag.GetHashCode();
                if (this.AngleFlag != null)
                    hashCode = hashCode * 59 + this.AngleFlag.GetHashCode();
                if (this.SignalFlag != null)
                    hashCode = hashCode * 59 + this.SignalFlag.GetHashCode();
                if (this.TimingFlag != null)
                    hashCode = hashCode * 59 + this.TimingFlag.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
